import * as O from "fp-ts/Option";
import { Kind2, URIS2 } from "fp-ts/HKT";
import { Functor2 } from "fp-ts/Functor";
import { Lazy } from "fp-ts/function";
import { Monad2 } from "fp-ts/Monad";
import { Alternative2 } from "fp-ts/Alternative";
import { Applicative2 } from "fp-ts/Applicative";
import { Foldable2 } from "fp-ts/Foldable";
import { Either } from "./Either";
import { Option } from "./Option";
export interface Absent {
    readonly _tag: "Absent";
}
export interface Invalid<E> {
    readonly _tag: "Invalid";
    readonly errors: E;
}
export interface Valid<A> {
    readonly _tag: "Valid";
    readonly value: A;
}
export declare type LocalValue<E, A> = Absent | Invalid<E> | Valid<A>;
export declare const URI = "LocalValue";
export declare type URI = typeof URI;
declare module "fp-ts/HKT" {
    interface URItoKind2<E, A> {
        readonly [URI]: LocalValue<E, A>;
    }
}
interface OptionalGetter<F extends URIS2> {
    readonly getOrElse: <E, A>(f: Lazy<A>) => (fa: Kind2<F, E, A>) => A;
}
export declare const fold: <E, A, B>(onNone: () => B, onError: (e: E) => B, onValue: (a: A) => B) => (fa: LocalValue<E, A>) => B;
export declare const fold2: <E, A, B>(onNone: () => B, onValue: (a: A) => B) => (fa: LocalValue<E, A>) => B;
export declare const getOrElse: <E, A>(defaultValue: Lazy<A>) => (lv: LocalValue<E, A>) => A;
export declare const of: <E, A>(v: A) => LocalValue<E, A>;
export declare const chain: <E, A, B>(f: (a: A) => LocalValue<E, B>) => (lv: LocalValue<E, A>) => LocalValue<E, B>;
export declare const map: <E, A, B>(f: (a: A) => B) => (lv: LocalValue<E, A>) => LocalValue<E, B>;
export declare const fromOption: <E, A>(o: Option<A>) => LocalValue<E, A>;
export declare const fromEither: <E, A>(e: Either<E, A>) => LocalValue<E, A>;
export declare const toOption: <E, A>(v: LocalValue<E, A>) => O.Option<A>;
export declare const toEither: <E, A>(onNone: Lazy<E>) => (v: LocalValue<E, A>) => Either<E, A>;
export declare const alt: <E, A>(la: Lazy<LocalValue<E, A>>) => (lv: LocalValue<E, A>) => LocalValue<E, A>;
export declare const isAbsent: (lv: LocalValue<any, any>) => lv is Absent;
export declare const isValid: <A>(lv: LocalValue<any, A>) => lv is Valid<A>;
export declare const isInvalid: <E>(lv: LocalValue<E, any>) => lv is Invalid<E>;
export declare const absent: LocalValue<never, never>;
export declare const valid: <A>(v: A) => LocalValue<never, A>;
export declare const invalid: <E>(e: E) => LocalValue<E, never>;
export declare const localValue: Functor2<URI> & Monad2<URI> & Alternative2<URI> & Applicative2<URI> & Foldable2<URI> & OptionalGetter<URI>;
export {};
