export declare const storeChangedCustomEvent = "storeChangedCustomEvent";
export declare function localStorageAvailable(): boolean;
export interface LocalStorageChangedEvent {
    detail: {
        key: string;
    };
}
export declare const isLocalStorageEvent: (e: any) => e is LocalStorageChangedEvent;
interface IProxyStorage {
    getItem(key: string): string | null;
    setItem(Key: string, value: string): void;
    removeItem(key: string): void;
}
export declare class LocalStorageProxy implements IProxyStorage {
    getItem(key: string): string | null;
    setItem(key: string, value: string): void;
    removeItem(key: string): void;
}
export declare class MemoryStorageProxy implements IProxyStorage {
    private _memoryStorage;
    getItem(key: string): string | null;
    setItem(key: string, value: string): void;
    removeItem(key: string): void;
}
export declare const localStorageProxy: LocalStorageProxy | MemoryStorageProxy;
export {};
